<div class="table-container mat-elevation-z8">
  <ng-scrollbar track="all">
    <mat-table [dataSource]="data">

      <ng-container matColumnDef="message">
        <mat-header-cell *matHeaderCellDef>
          <mat-icon class="">report_problem</mat-icon>
          <span>Message</span>
        </mat-header-cell>
        <mat-cell *matCellDef="let element">{{ element.message | ellipsis }}</mat-cell>
      </ng-container>

      <ng-container matColumnDef="date">
        <mat-header-cell *matHeaderCellDef>
          <span>Date</span>
        </mat-header-cell>
        <mat-cell *matCellDef="let element">{{ element.date | date:'MM/dd/yyyy, HH:mm' }}</mat-cell>
      </ng-container>

      <ng-container matColumnDef="origin">
        <mat-header-cell *matHeaderCellDef>
          <span>Origin</span>
        </mat-header-cell>
        <mat-cell *matCellDef="let element">{{ element.origin }}</mat-cell>
      </ng-container>

      <ng-container matColumnDef="type">
        <mat-header-cell *matHeaderCellDef>
          <span>Type</span>
        </mat-header-cell>
        <mat-cell *matCellDef="let element">{{ element.type }}</mat-cell>
      </ng-container>

      <mat-header-row @rowAnimation *matHeaderRowDef="displayedColumns; sticky: true"></mat-header-row>
      <mat-row @rowAnimation *matRowDef="let row; columns: displayedColumns;" (click)="showDetails(row)"></mat-row>
    </mat-table>
  </ng-scrollbar>
  <mat-paginator [length]="resultsLength" [pageSizeOptions]="pageSizeOptions" [pageSize]="pageSize"></mat-paginator>
</div>

<ng-template #detail let-log>
  <h1 mat-dialog-title>{{ log.message | ellipsis }}</h1>
  <mat-dialog-content>
    <ul>
      <li>{{ log.date | date:'MM/dd/yyyy, HH:mm' }}</li>
      <li>{{ log.origin }}</li>
      <li>{{ log.type }}</li>
    </ul>
    <pre *ngIf="log.trace" [innerHTML]="log.trace"></pre>
  </mat-dialog-content>
</ng-template>
